let BanList = JsonIO.read('config/HaxysHideout/BannedItems.json') || [];

console.log(`Loaded banlist of length: ${BanList.BannedItems?.length}`)

ServerEvents.recipes((event) => {
    BanList.BannedItems.forEach((HaxyBannedRecipes) => {
        event.remove({
            id: HaxyBannedRecipes
        });
    });


    BanList.BannedRecipes.forEach((HaxyBannedItems) => {
        event.remove({
            output: HaxyBannedItems
        });
    });

});


function isBannedItem(itemId) {
    return BanList.BannedItems.some(bannedItem => bannedItem === itemId);
}

PlayerEvents.inventoryChanged(event => {
    for (let i = 0; i < event.player.inventory.containerSize; i++) {
        let currentItem = event.player.inventory.getItem(i);
        if (isBannedItem(currentItem.id)) {
            event.player.tell([
                Text.yellow(Text.translate(currentItem.descriptionId)),
                " is a banned item and has been removed",
                "\n",
                Text.gold("Please see our website for a full list of banned items - "),
                Text.red("Click Here").click("https://haxyshideout.co.uk/hexlite/faq/banned-items")
            ]);
            event.player.inventory.setItem(i, "minecraft:air");
            console.log("Banned Item: " + currentItem.id + " has been removed from inventory of " + event.player.getName().getString());
        }
    }
});

ItemEvents.rightClicked(event => {
    if (isBannedItem(event.item.id)) {
        for (let i = 0; i < event.player.inventory.containerSize; i++) {
            if (event.player.inventory.getItem(i).id === event.item.id) {
                event.player.inventory.setItem(i, "minecraft:air");
            }
        }

        event.player.tell([
            Text.yellow(Text.translate(event.item.descriptionId)),
            " is a banned item and has been removed",
            "\n",
            Text.gold("Please see our website for a full list of banned items - "),
            Text.red("Click Here").click("https://haxyshideout.co.uk/hexlite/faq/banned-items")
        ]);

        console.log("Banned Item: " + event.item.id + " has been removed from inventory of " + event.player.getName().getString());
    }
});

BlockEvents.rightClicked(event => {
    if (isBannedItem(event.block.id)) {
        event.block.set("minecraft:air");
        event.player.tell([
            Text.yellow(Text.translate(Item.of(event.block).descriptionId)),
            " is a banned item and has been removed",
            "\n",
            Text.gold("Please see our website for a full list of banned items - "),
            Text.red("Click Here").click("https://haxyshideout.co.uk/hexlite/faq/banned-items")
        ]);

        console.log("Banned Item: " + event.block.id + " has been interacted with in-world by " + event.player.getName().getString() + " the block has been removed");
    }
});

BlockEvents.placed(event => {
    if (isBannedItem(event.block.id)) {
        event.block.set("minecraft:air");
        event.player.tell([
            Text.yellow(Text.translate(Item.of(event.block).descriptionId)),
            " is a banned item and has been removed",
            "\n",
            Text.gold("Please see our website for a full list of banned items - "),
            Text.red("Click Here").click("https://haxyshideout.co.uk/hexlite/faq/banned-items")
        ]);

        console.log("Banned Item: " + event.block.id + " has been placed in-world by " + event.player.getName().getString() + " the block has been removed");
    }
});