/*

All monsters are in order of power.

Note: All mobs from cataclysm are massive and are boss tier,
unless otherwise specified.

Some mobs can have a size property which will be noted
*/

const MYTHICAL_MONSTERS = [
    // Dragons go from t1 to t5 in terms of power and size.
    "iceandfire:lightning_dragon", // Size 1-5
    "iceandfire:ice_dragon", // Size 1-5
    "iceandfire:fire_dragon", // Size 1-5
    
    "alexscaves:tremorzilla", // Dinosaur RAID BOSS
    "alexscaves:luxtructosaurus", // Dinosaur RAID BOSS
  
    // Weaker than T4 dragon
    "cataclysm:netherite_monstrosity",
    "cataclysm:ignis",
  
    // Weaker than T3 dragon
    "cataclysm:ender_guardian",
    "cataclysm:ender_golem",
    "minecraft:wither",
    "iceandfire:hydra",
    "realmrpg_demons:ancient_demon_lord",
  
    // Weaker than T2 dragon
    "iceandfire:cyclops",
    "irons_spellbooks:dead_king",
    "realmrpg_demons:demon_lord",
    "alexscaves:tremorsaurus", // Dinosaur
    "cataclysm:kobolediator", // Not a boss, but very strong guard mob.
    "minecraft:warden",
    "iceandfire:gorgon",
    "iceandfire:troll",
  
    // Weaker than T1 dragon
    "cataclysm:coral_golem",
    "iceandfire:deathworm", // Strength depends on size
    "iceandfire:amphithere",
    "cataclysm:amethyst_crab", // Not a boss, does not attack until provoked.
    "iceandfire:cockatrice",
  
    "mutantmonsters:mutant_skeleton",
    "mutantmonsters:mutant_creeper",
    "mutantmonsters:mutant_zombie",
  
    "cataclysm:ignited_berserker", // Not a boss
    "cataclysm:ignited_revenant", // Not a boss
    "realmrpg_demons:demon",
  
    "alexscaves:relicheirus", // Dinosaur
  
    "realmrpg_demons:demon_minion",
    "iceandfire:dread_knight",
    "realmrpg_demons:imp_guard",
    "realmrpg_demons:chort",
    "realmrpg_demons:imp",
    "cataclysm:koboleton", // Not a boss weak minion
    "irons_spellbooks:citadel_keeper",
    "iceandfire:ghost",
    
    "irons_spellbooks:necromancer",
    "alexscaves:vallumraptor", // Small dinosaur
    "iceandfire:dread_beast",
    "iceandfire:dread_scuttler",
    "realmrpg_wyrms:ender_wyrm",
    "realmrpg_wyrms:red_wyrm",
  
    "bygonenether:wither_skeleton_knight",
    "iceandfire:ghost",
    "minecraft:wither_skeleton",
    "bygonenether:wex",
    "iceandfire:dread_thrall",
    "iceandfire:pixie", // Very weak and annoying
    "minecraft:phantom", // Size 1-3
    
    "minecraft:skeleton",
    "minecraft:husk",
    "minecraft:zombie",
    "minecraft:slime" // Size 1-5
  ]
  
  /*
  
  F Tier Gateways
  
  */
  
  const SLIME_GATEWAY = {
    gateId: "SLIME_GATEWAY",
    tier: 'F',
    waves:  [
        [ { type: "minecraft:slime", amount: 6, size: 2 }, { type: "minecraft:slime", amount: 4, size: 2 } ],
        [ { type: "minecraft:slime", amount: 3, size: 2 }, { type: "minecraft:slime", amount: 4, size: 3 } ],
        [ { type: "minecraft:slime", amount: 1, size: 5 } ],
    ],
    description: "Small, slippery and fast.. or maybe not so small.."
  }
  
  
  const UNDEAD_HORDE_GATEWAY = {
    gateId: "UNDEAD_HORDE_GATEWAY",
    tier: 'F',
    waves:  [
        [ { type: "minecraft:zombie", amount: 7 }, { type: "minecraft:skeleton", amount: 3 } ],
        [ { type: "iceandfire:ghost", amount: 5 }, { type: "minecraft:skeleton", amount: 3 }, { type: "minecraft:zombie", amount: 7 }, ],
        [ { type: "irons_spellbooks:necromancer", amount: 2}, { type: "minecraft:zombie", amount: 25 }, { type: "iceandfire:ghost", amount: 3 }],
    ],
    description: "A large horde of low ranking undead, and their summoners.."
  }
  
  
  const HAUNTED_GATEWAY = {
    gateId: "HAUNTED_GATEWAY",
    tier: 'F',
    waves:  [
        [ { type: "iceandfire:ghost", amount: 5 }, { type: "minecraft:phantom", amount: 3 } ],
        [ { type: "iceandfire:ghost", amount: 7 }, { type: "minecraft:phantom", amount: 5 } ], 
        [ { type: "irons_spellbooks:necromancer", amount: 2 }, { type: "minecraft:phantom", amount: 4 } ],
        
    ],
    description: "A haunted gateway, with ghostly apparitions and phantoms.."
  }
  
  
  const PIXIE_SWARM_GATEWAY = {
    gateId: "PIXIE_SWARM_GATEWAY",
    tier: 'F',
    waves: [
        [ { type: "iceandfire:pixie", amount: 15 } ],
        [ { type: "iceandfire:pixie", amount: 20 }, { type: "minecraft:phantom", amount: 5 } ],
        [ { type: "iceandfire:pixie", amount: 25 }, { type: "iceandfire:ghost", amount: 5 } ],
    ],
    description: "A mischievous swarm of pixies causing trouble..."
  }
  
  const DREAD_THRALL_INVASION_GATEWAY = {
    gateId: "DREAD_THRALL_INVASION_GATEWAY",
    tier: 'F',
    waves: [
        [ { type: "iceandfire:dread_thrall", amount: 10 } ],
        [ { type: "iceandfire:dread_thrall", amount: 15 }, { type: "iceandfire:dread_scuttler", amount: 5 } ],
        [ { type: "iceandfire:dread_thrall", amount: 20 }, { type: "iceandfire:dread_scuttler", amount: 10 } ],
    ],
    description: "An invasion of dread thralls from the icy depths..."
  }
  
  const WYRMS_INFESTATION_GATEWAY = {
    gateId: "WYRMS_INFESTATION_GATEWAY",
    tier: 'F',
    waves: [
        [ { type: "realmrpg_wyrms:red_wyrm", amount: 5 } ],
        [ { type: "realmrpg_wyrms:red_wyrm", amount: 8 }, { type: "realmrpg_wyrms:ender_wyrm", amount: 3 } ],
        [ { type: "realmrpg_wyrms:red_wyrm", amount: 12 }, { type: "realmrpg_wyrms:ender_wyrm", amount: 5 } ],
    ],
    description: "A swarm of small but dangerous wyrms..."
  }
  
  
  const SKELETON_MARCH_GATEWAY = {
    gateId: "SKELETON_MARCH_GATEWAY",
    tier: 'F',
    waves: [
        [ { type: "minecraft:skeleton", amount: 10 } ],
        [ { type: "minecraft:skeleton", amount: 15 }, { type: "minecraft:phantom", amount: 5 } ],
        [ { type: "minecraft:skeleton", amount: 20 }, { type: "iceandfire:ghost", amount: 5 } ],
    ],
    description: "A marching band of skeletons approaches..."
  };
  
  const PHANTOM_NIGHT_GATEWAY = {
    gateId: "PHANTOM_NIGHT_GATEWAY",
    tier: 'F',
    waves: [
        [ { type: "minecraft:phantom", amount: 5 } ],
        [ { type: "minecraft:phantom", amount: 7 }, { type: "iceandfire:ghost", amount: 3 } ],
        [ { type: "minecraft:phantom", amount: 10 }, { type: "iceandfire:ghost", amount: 5 } ],
    ],
    description: "The night brings forth a swarm of phantoms..."
  };
  
  const KOBOLD_RAID_GATEWAY = {
    gateId: "KOBOLD_RAID_GATEWAY",
    tier: 'F',
    waves: [
        [ { type: "cataclysm:koboleton", amount: 10 } ],
        [ { type: "cataclysm:koboleton", amount: 15 }, { type: "minecraft:skeleton", amount: 5 } ],
        [ { type: "cataclysm:kobolediator", amount: 1}, { type: "iceandfire:dread_thrall", amount: 5 } ],
    ],
    description: "A small raid of kobold skeletons emerges..."
  };
  
  /*
  
  E Tier Gateways
  
  */
  
  const COCKATRICE_NEST_GATEWAY = {
    gateId: "COCKATRICE_NEST_GATEWAY",
    tier: 'E',
    waves:  [
        [ { type: "iceandfire:cockatrice", amount: 5 }, { type: "minecraft:chicken", amount: 12 }],
    ],
    description: "A nest of cockatrices, with their hatchlings.."
  }   
  
  const DEMON_SCOUTING_PARTY_GATEWAY = {
    gateId: "DEMON_SCOUTING_PARTY_GATEWAY",
    tier: 'E',
    waves:  [
        [ { type: "realmrpg_demons:imp", amount: 3 }],
        [ { type: "realmrpg_demons:imp_guard", amount: 2 }, { type: "realmrpg_demons:imp", amount: 5 }],
        [ { type: "realmrpg_demons:demon", amount: 1 }],
    ],
    description: "A demonic scouting party.."
  }       
  
  const BABY_DINOSAUR_GATEWAY = {
    gateId: "BABY_DINOSAUR_GATEWAY",
    tier: 'E',
    waves:  [
        [ { type: "alexscaves:vallumraptor", amount: 3 }, { type: "alexscaves:relicheirus", amount: 1}],
    ],
    description: "Prehistoric escapees.."
  }
  
  const SKELETAL_WARRIORS_GATEWAY = {
    gateId: "SKELETAL_WARRIORS_GATEWAY",
    tier: 'E',
    waves:  [
        [ { type: "minecraft:wither_skeleton", amount: 3 }, { type: "iceandfire:dread_knight", amount: 2}],
        [ { type: "minecraft:wither_skeleton", amount: 3 }, { type: "iceandfire:dread_knight", amount: 4}, { type: "bygonenether:wex", amount: 7}],
        [ { type: "mutantmonsters:mutant_skeleton", amount: 1 }, { type: "iceandfire:dread_knight", amount: 2}, { type: "bygonenether:wex", amount: 7}],
  
    ],
    description: "A legion of skeletal warriors.."
  }
  
  
  const IMP_HORDES_GATEWAY = {
    gateId: "IMP_HORDES_GATEWAY",
    tier: 'E',
    waves: [
        [ { type: "realmrpg_demons:imp", amount: 10 } ],
        [ { type: "realmrpg_demons:imp", amount: 15 }, { type: "realmrpg_demons:imp_guard", amount: 3 } ],
        [ { type: "realmrpg_demons:imp_guard", amount: 5 }, { type: "realmrpg_demons:chort", amount: 2 } ],
    ],
    description: "An onslaught of mischievous imps and their guards..."
  }
  
  const DREAD_KNIGHTS_GATEWAY = {
    gateId: "DREAD_KNIGHTS_GATEWAY",
    tier: 'E',
    waves: [
        [ { type: "iceandfire:dread_knight", amount: 4 } ],
        [ { type: "iceandfire:dread_knight", amount: 6 }, { type: "iceandfire:dread_beast", amount: 3 } ],
        [ { type: "iceandfire:dread_knight", amount: 8 }, { type: "mutantmonsters:mutant_skeleton", amount: 1 } ],
    ],
    description: "A battalion of dread knights marches forward..."
  }
  
  const CREEPER_CHAOS_GATEWAY = {
    gateId: "CREEPER_CHAOS_GATEWAY",
    tier: 'E',
    waves: [
        [ { type: "minecraft:creeper", amount: 7 } ],
        [ { type: "minecraft:creeper", amount: 10 }, { type: "mutantmonsters:mutant_creeper", amount: 1 } ],
        [ { type: "mutantmonsters:mutant_creeper", amount: 2 } ],
    ],
    description: "A horde of creepers, ready to explode..."
  }
  
  
  /*
  1
  D Tier Gateways
  
  */
  
  const GORGON_GAZE_GATEWAY = {
    gateId: "GORGON_GAZE_GATEWAY",
    tier: 'D',
    waves: [
        [ { type: "iceandfire:gorgon", amount: 1 } ],
        [ { type: "iceandfire:gorgon", amount: 1 }, { type: "iceandfire:cockatrice", amount: 5 } ],
        [ { type: "iceandfire:gorgon", amount: 2 } ],
    ],
    description: "Beware the petrifying gaze of the gorgons..."
  }; 
  
  const OVERSIZED_WILDLIFE_GATEWAY = {
    gateId: "OVERSIZED_WILDLIFE_GATEWAY",
    tier: 'D',
    waves:  [
        [ { type: "cataclysm:amethyst_crab", amount: 3 }, {  type: "cataclysm:coral_golem", amount: 1}],
    ],
    description: "A herd of oversized wildlife.."
  }   
  
  
  const ZOMBIE_HORDE_GATEWAY = {
    gateId: "ZOMBIE_HORDE_GATEWAY",
    tier: 'D',
    waves:  [
        [ { type: "minecraft:zombie", amount: 17 }, { type: "minecraft:husk", amount: 17 }, { type: "irons_spellbooks:necromancer", amount: 1 }],
        [ { type: "mutantmonsters:mutant_zombie", amount: 3 }, { type: "minecraft:zombie", amount: 15 }],
    ],
    description: "A horde of zombies.."
  }   
  
  
  const DREAD_GATEWAY = {
    gateId: "DREAD_GATEWAY",
    tier: 'D',
    waves:  [
        [ { type: "iceandfire:dread_knight", amount: 3 }, { type: "iceandfire:dread_beast", amount: 5}, { type: "iceandfire:dread_scuttler", amount: 3}, { type: "iceandfire:dread_thrall", amount: 7 }],
    ],
    description: "A gateway to the dread realms.."
  }
  
  
  const DEMON_SQUAD_GATEWAY = {
    gateId: "DEMON_SQUAD_GATEWAY",
    tier: 'D',
    waves:  [
        [ { type: "realmrpg_demons:imp_guard", amount: 6 }, { type: "realmrpg_demons:demon", amount: 1}, { type: "realmrpg_demons:chort", amount: 2}],
        [ { type: "realmrpg_demons:demon", amount: 3 },  { type: "realmrpg_demons:imp_guard", amount: 7}, { type: "realmrpg_demons:chort", amount: 2}],
    ],
    description: "A squad of demons.."
  }
  
  const DEMON_ASSAULT_GATEWAY = {
    gateId: "DEMON_ASSAULT_GATEWAY",
    tier: 'D',
    waves: [
        [ { type: "realmrpg_demons:demon", amount: 3 } ],
        [ { type: "realmrpg_demons:demon", amount: 5 }, { type: "realmrpg_demons:chort", amount: 3 } ],
        [ { type: "realmrpg_demons:demon", amount: 7 }, { type: "realmrpg_demons:demon_lord", amount: 1 } ],
    ],
    description: "A fierce assault by demons..."
  };
  
  const AMPHITHERE_ATTACK_GATEWAY = {
    gateId: "AMPHITHERE_ATTACK_GATEWAY",
    tier: 'D',
    waves: [
        [ { type: "iceandfire:amphithere", amount: 3 } ],
        [ { type: "iceandfire:amphithere", amount: 5 }, { type: "minecraft:phantom", amount: 7 } ],
        [ { type: "iceandfire:amphithere", amount: 7 }, { type: "iceandfire:cockatrice", amount: 5 } ],
    ],
    description: "An aerial assault by amphitheres..."
  }
  
  const TROLL_INVASION_GATEWAY = {
    gateId: "TROLL_INVASION_GATEWAY",
    tier: 'D',
    waves: [
        [ { type: "iceandfire:troll", amount: 1 } ],
        [ { type: "iceandfire:troll", amount: 2 }, { type: "minecraft:zombie", amount: 15 } ],
        [ { type: "iceandfire:troll", amount: 3 } ],
    ],
    description: "A menacing group of trolls approach..."
  }
  
  const INFERNAL_SCOUTS_GATEWAY = {
    gateId: "INFERNAL_SCOUTS_GATEWAY",
    tier: 'D',
    waves: [
        [ { type: "cataclysm:ignited_berserker", amount: 2 }, { type: "bygonenether:wex", amount: 5 } ],
        [ { type: "cataclysm:ignited_berserker", amount: 4 }, { type: "cataclysm:ignited_revenant", amount: 3 } ],
    ],
    description: "A small group of infernal scouts..."
  }
  
  /*
  
  C Tier Gateways
  
  */
  
  const ONE_EYED_GATEWAY = {
    gateId: "ONE_EYED_GATEWAY",
    tier: 'C',
    waves:  [
        [ { type: "minecraft:warden", amount: 3 }],
        [ { type: "iceandfire:cyclops", amount: 1 }, {type: "minecraft:sheep", amount: 7}],
    ],
    description: "A warden.."
  }   
  
  const INFERNAL_GATEWAY = {
    gateId: "INFERNAL_GATEWAY",
    tier: 'C',
    waves:  [
        [ { type: "cataclysm:ignited_berserker", amount: 3 }, { type: "bygonenether:wex", amount: 8}, { type: "cataclysm:ignited_revenant", amount: 3}],
        [ { type: "cataclysm:ignited_berserker", amount: 5 }, { type: "cataclysm:kobolediator", amount: 1}, { type: "cataclysm:ignited_revenant", amount: 3}],
    ],
    description: "A gateway to the infernal realms.."   
  }
  
  const GIANT_GATEWAY = {
    gateId: "GIANT_GATEWAY",
    tier: 'C',
    waves:  [
        [ { type: "iceandfire:troll", amount: 3 }, {type: "minecraft:sheep", amount: 14}],
        [ { type: "iceandfire:cyclops", amount: 1 }],
    ],
    description: "A hierarchy of giants..."
  }
  
  const MYTHICAL_BEASTS_GATEWAY = {
    gateId: "MYTHICAL_BEASTS_GATEWAY",
    tier: 'C',
    waves:  [
        [ { type: "iceandfire:cockatrice", amount: 4 }, { type: "iceandfire:deathworm", amount: 3 }],
        [ { type: "iceandfire:amphithere", amount: 2 }, { type: "iceandfire:gorgon", amount: 2 }],
        [ { type: "iceandfire:hydra", amount: 1 }],
    ],
    description: "A hierarchy of mythical beasts..."
  }
  
  
  
  const WARDEN_OF_THE_DEPTHS_GATEWAY = {
    gateId: "WARDEN_OF_THE_DEPTHS_GATEWAY",
    tier: 'C',
    waves: [
        [ { type: "minecraft:warden", amount: 1 }, { type: "mutantmonsters:mutant_zombie", amount: 2 } ],
        [ { type: "minecraft:warden", amount: 2 }, { type: "cataclysm:kobolediator", amount: 2 } ],
        [ { type: "minecraft:warden", amount: 3 } ],
    ],
    description: "Wardens from the deep caves have emerged..."
  };
  
  const MUTANT_MAYHEM_GATEWAY = {
    gateId: "MUTANT_MAYHEM_GATEWAY",
    tier: 'C',
    waves: [
        [ { type: "mutantmonsters:mutant_skeleton", amount: 2 }, { type: "mutantmonsters:mutant_zombie", amount: 2 } ],
        [ { type: "mutantmonsters:mutant_creeper", amount: 2 }, { type: "mutantmonsters:mutant_zombie", amount: 3 } ],
        [ { type: "mutantmonsters:mutant_skeleton", amount: 3 }, { type: "mutantmonsters:mutant_creeper", amount: 3 } ],
    ],
    description: "A mayhem of mutant creatures..."
  };
  
  const CITADEL_DEFENDERS_GATEWAY = {
    gateId: "CITADEL_DEFENDERS_GATEWAY",
    tier: 'C',
    waves: [
        [ { type: "irons_spellbooks:citadel_keeper", amount: 2 }, { type: "iceandfire:dread_knight", amount: 5 } ],
        [ { type: "irons_spellbooks:citadel_keeper", amount: 3 } ],
        [ { type: "irons_spellbooks:citadel_keeper", amount: 4 }, { type: "cataclysm:kobolediator", amount: 2 } ],
    ],
    description: "Defenders of the citadel stand guard..."
  };
  
  
  const DEMONIC_LORD_GATEWAY = {
    gateId: "DEMONIC_LORD_GATEWAY",
    tier: 'C',
    waves:  [
        [ { type: "realmrpg_demons:demon", amount: 3 },  { type: "realmrpg_demons:imp_guard", amount: 7}, { type: "realmrpg_demons:chort", amount: 5}],
        [ { type: "realmrpg_demons:demon_lord", amount: 1 }, { type: "realmrpg_demons:demon", amount: 3}, { type: "realmrpg_demons:imp_guard", amount: 7}],
    ],
    description: "A demonic lord.."
  }
  
  /*
  
  B Tier Gateways
  
  */
  
  const BABY_DRAGON_GATEWAY = {
    gateId: "BABY_DRAGON_GATEWAY",
    tier: 'B'   ,
    waves:  [
        [ { type: "iceandfire:fire_dragon", amount: 1, size: 1 }, { type: "iceandfire:red_wyrm", amount: 11}],
    ],
    description: "A nest of baby dragons.."
  }
  
  const DEAD_KING_GATEWAY = {
    gateId: "DEAD_KING_GATEWAY",
    tier: 'B',
    waves:  [
        [ { type: "irons_spellbooks:dead_king", amount: 1 },  { type: "irons_spellbooks:necromancer", amount: 3}, { type: "minecraft:zombie", amount: 17 }, { type: "minecraft:skeleton", amount: 17 }],
    ],
    description: "A dead king.."
  }
  
  const DINOSAUR_GATEWAY = {
    gateId: "DINOSAUR_GATEWAY",
    tier: 'B',
    waves:  [
        [ { type: "alexscaves:tremorsaurus", amount: 6 }, { type: "alexscaves:vallumraptor", amount: 11}],
    ],
    description: "Many dinosaurs..."
  }
  
  
  const CITADEL_SIEGE_GATEWAY = {
    gateId: "CITADEL_SIEGE_GATEWAY",
    tier: 'B',
    waves: [
        [ { type: "irons_spellbooks:citadel_keeper", amount: 5 }, { type: "mutantmonsters:mutant_skeleton", amount: 2 } ],
        [ { type: "irons_spellbooks:citadel_keeper", amount: 7 }, { type: "iceandfire:hydra", amount: 1 } ],
        [ { type: "irons_spellbooks:citadel_keeper", amount: 10 }, { type: "minecraft:wither", amount: 1 } ],
    ],
    description: "The citadel is under siege by formidable foes..."
  };
  
  const WITHER_ASSAULT_GATEWAY = {
    gateId: "WITHER_ASSAULT_GATEWAY",
    tier: 'B',
    waves: [
        [ { type: "minecraft:wither_skeleton", amount: 15 } ],
        [ { type: "bygonenether:wither_skeleton_knight", amount: 7 }, { type: "mutantmonsters:mutant_skeleton", amount: 3 } ],
        [ { type: "minecraft:wither", amount: 1 } ],
    ],
    description: "An assault led by wither skeletons and their master..."
  };
  
  const DEMONIC_OVERLORD_GATEWAY = {
    gateId: "DEMONIC_OVERLORD_GATEWAY",
    tier: 'B',
    waves:  [
        [ { type: "realmrpg_demons:imp", amount: 5 }, { type: "realmrpg_demons:imp_guard", amount: 3 }, { type: "realmrpg_demons:demon", amount: 2 }],
        [ { type: "realmrpg_demons:imp_guard", amount: 7 }, { type: "realmrpg_demons:demon", amount: 5 }, { type: "realmrpg_demons:demon", amount: 3 }],
        [ { type: "realmrpg_demons:demon", amount: 10 }, { type: "realmrpg_demons:demon", amount: 7 }, { type: "realmrpg_demons:demon_lord", amount: 2 }],
        [ { type: "realmrpg_demons:demon_lord", amount: 3 }, { type: "realmrpg_demons:ancient_demon_lord", amount: 1 }],
    ],
    description: "A demonic overlord, commanding a vast army of lesser demons.."
  }
  
  /*
  
  
  A Tier Gateways
  
  */
  
  const ICE_TWINS_GATEWAY = {
    gateId: "ICE_TWINS_GATEWAY",
    tier: 'A',
    waves:  [
        [ { type: "iceandfire:ice_dragon", amount: 2, size: 2 }],
    ],
    description: "Two twins as cold as ice.."
  }
  
  const LIGHTNING_PREDATOR_GATEWAY = {
    gateId: "LIGHTNING_PREDATOR_GATEWAY",
    tier: 'A',
    waves:  [
        [ { type: "iceandfire:lightning_dragon", amount: 1, size: 3 }],
    ],
    description: "A predator of the skies.."
  }
  
  const TWIN_HEADED_GATEWAY = {
    gateId: "TWIN_HEADED_GATEWAY",
    tier: 'A',
    waves:  [
        [ { type: "iceandfire:hydra", amount: 2}],
    ],
    description: "Two heads are better than one.."
  }
  
  const CASTLE_GUARDS_GATEWAY = {
    gateId: "CASTLE_GUARDS_GATEWAY",
    tier: 'A',
    waves:  [
        [ { type: "cataclysm:kobolediator", amount:5 }, { type: "iceandfire:dread_knight", amount: 10}],
        [ { type: "cataclysm:ender_golem", amount: 1}],
    ],
    description: "They are protecting something.."
  }
  
  const THE_UNDEAD_ARMY = {
    gateId: "THE_UNDEAD_ARMY",
    tier: 'A',
    waves:  [
        [ { type: "minecraft:zombie", amount: 30 }, { type: "minecraft:husk", amount: 30 }, { type: "iceandfire:ghost", amount: 15 }],
        [ { type: "irons_spellbooks:necromancer", amount: 5 }, { type: "bygonenether:wither_skeleton_knight", amount: 7 }, { type: "irons_spellbooks:citadel_keeper", amount: 3 }, { type: "mutantmonsters:mutant_zombie", amount: 4 }],
        [ { type: "mutantmonsters:mutant_skeleton", amount: 4 }, { type: "mutantmonsters:mutant_creeper", amount: 4 }, { type: "iceandfire:ghost", amount: 10 }, { type: "minecraft:zombie", amount: 20 }],
        [ { type: "minecraft:wither", amount: 1 }],
    ],
    description: "An endless horde of undead and their ruler.."
  }
  
  
  
  const FROST_DRAGON_ASSAULT_GATEWAY = {
    gateId: "FROST_DRAGON_ASSAULT_GATEWAY",
    tier: 'A',
    waves: [
        [ { type: "iceandfire:ice_dragon", amount: 1, size: 3 }, { type: "iceandfire:ice_dragon", amount: 2, size: 2 } ],
        [ { type: "iceandfire:ice_dragon", amount: 1, size: 4 } ],
    ],
    description: "An assault by frost dragons chills the air..."
  };
  
  const NETHERITE_GUARDIANS_GATEWAY = {
    gateId: "NETHERITE_GUARDIANS_GATEWAY",
    tier: 'A',
    waves: [
        [ { type: "cataclysm:kobolediator", amount: 5 } ],
        [ { type: "cataclysm:ender_golem", amount: 2 }, { type: "cataclysm:kobolediator", amount: 3 } ],
        [ { type: "cataclysm:ender_golem", amount: 3 } ],
    ],
    description: "Guardians made of netherite stand in your way..."
  };
  
  const ANCIENT_DEMON_GATEWAY = {
    gateId: "ANCIENT_DEMON_GATEWAY",
    tier: 'A',
    waves: [
        [ { type: "realmrpg_demons:demon_lord", amount: 3 } ],
        [ { type: "realmrpg_demons:ancient_demon_lord", amount: 1 }, { type: "realmrpg_demons:demon_lord", amount: 2 } ],
        [ { type: "realmrpg_demons:ancient_demon_lord", amount: 2 } ],
    ],
    description: "Ancient demons rise to challenge you..."
  };
  
  const ELEMENTAL_CLASH_GATEWAY = {
    gateId: "ELEMENTAL_CLASH_GATEWAY",
    tier: 'A',
    waves: [
        [ { type: "iceandfire:fire_dragon", amount: 1, size: 3 }, { type: "iceandfire:ice_dragon", amount: 1, size: 3 } ],
        [ { type: "iceandfire:hydra", amount: 2 } ],
        [ { type: "iceandfire:lightning_dragon", amount: 1, size: 3 } ],
    ],
    description: "An elemental clash of fire, ice, and lightning..."
  };
  
  /*
  
  S Tier Gateways
  
  */
  const APEX_PREDATOR_GATEWAY = {
    gateId: "APEX_PREDATOR_GATEWAY",
    tier: 'S',
    waves:  [
        [ { type: "iceandfire:fire_dragon", amount: 1, size: 4 },  { type: "realmrpg_wyrms:red_wyrm", amount: 11 }, { type: "minecraft:sheep", amount: 17 }],
    ],
    description: "The apex predator.."
  }
  
  
  const SMAUG_THE_DRAGON_GATEWAY = {
    gateId: "SMAUG_THE_DRAGON_GATEWAY",
    tier: 'S',
    waves:  [
        [ { type: "iceandfire:fire_dragon", amount: 1, size: 5 }],
    ],
    description: "Thank you for the treat it was very tasty ;)"  
  }     

  const ENDER_GOLEMS_GATEWAY = {
    gateId: "ENDER_GOLEMS_GATEWAY",
    tier: 'S',
    waves:  [
        [ { type: "cataclysm:ender_golem", amount: 3 }, { type: "cataclysm:ender_guardian", amount: 1}, { type: "realmrpg_wyrms:ender_wyrm", amount: 7} ],
    ],
    description: "A horde of ender golems.."
  }
  
  const SNAKES_AND_BIRDS_GATEWAY = {
    gateId: "SNAKES_AND_BIRDS_GATEWAY",
    tier: 'S',
    waves:  [
        [ { type: "iceandfire:cockatrice", amount: 13 },  { type: "iceandfire:hydra", amount: 7 }, { type: "cataclysm:amethyst_crab", amount: 4}],
        
    ],
    description: "Snakes and birds..."    
  }
  
  const DEMON_KINGS_CASTLE_WAR = {
    gateId: "DEMON_KINGS_CASTLE_WAR",
    tier: 'S',
    waves:  [
        [ { type: "realmrpg_demons:imp", amount: 10 }, { type: "realmrpg_demons:imp_guard", amount: 6 }, { type: "realmrpg_demons:demon", amount: 4 }, { type: "minecraft:wither_skeleton", amount: 5 }, { type: "bygonenether:wither_skeleton_knight", amount: 3 }],
        [ { type: "realmrpg_demons:imp_guard", amount: 14 }, { type: "realmrpg_demons:demon", amount: 10 }, { type: "realmrpg_demons:demon", amount: 6 }, { type: "minecraft:wither_skeleton", amount: 5 }, { type: "bygonenether:wither_skeleton_knight", amount: 3 }],
        [ { type: "realmrpg_demons:demon", amount: 20 }, { type: "realmrpg_demons:demon", amount: 14 }, { type: "realmrpg_demons:demon_lord", amount: 4 }, { type: "minecraft:wither_skeleton", amount: 5 }, { type: "bygonenether:wither_skeleton_knight", amount: 3 }],
        [ { type: "realmrpg_demons:demon_lord", amount: 3 }, { type: "realmrpg_demons:ancient_demon_lord", amount: 1 }, { type: "minecraft:wither", amount: 1 }, { type: "minecraft:wither_skeleton", amount: 5 }, { type: "bygonenether:wither_skeleton_knight", amount: 3 }, { type: "bossominium:hell_hound_boss", amount: 1}],
    ],
    description: "The Demon King's castle, filled with an overwhelming army of demons and withers.."
  }
  
  const OVER_THE_RAINBOW_GATEWAY = {
    gateId: "OVER_THE_RAINBOW_GATEWAY",
    tier: 'S',
    waves:  [
        [ { type: "iceandfire:fire_dragon", amount: 1, size: 4 }, { type: "iceandfire:ice_dragon", amount: 1, size: 4 }, { type: "iceandfire:lightning_dragon", amount: 1, size: 4 }],
    ],
    description: "So many colours.."
  }

  
  /*
  
  SS Gateways
  
  */
  
  const LARGER_THAN_BOULDERS_GATEWAY = {
    gateId: "LARGER_THAN_BOULDERS_GATEWAY",
    tier: 'SS',
    waves:  [
        [ { type: "cataclysm:coral_golem", amount: 4 }, { type: "cataclysm:amethyst_crab", amount: 3 }],
        [ { type: "cataclysm:coral_golem", amount: 7 }, { type: "cataclysm:ender_golem", amount: 3 }],
        [ { type: "cataclysm:ender_golem", amount: 5 }, { type: "cataclysm:ender_guardian", amount: 3 }],
        [ { type: "cataclysm:netherite_monstrosity", amount: 1 }],
    ],
    description: "Rock solid.."
  }
  
  
    
  const THE_GUARDIAN_GATEWAY = {
    gateId: "THE_GUARDIAN_GATEWAY",
    tier: 'SS',
    waves:  [
        [{ type: "cataclysm:kobolediator", amount: 16}],
        [ { type: "bossominium:crypt_mummy_boss", amount: 1 }, { type: "cataclysm:ender_guardian", amount: 3}, { type: "cataclysm:kobolediator", amount: 8}],
    ],
    description: "... . ..... ... .. ."
  }

  const PREHISTORICAL_DISASTER_GATEWAY = {
    gateId: "PREHISTORICAL_DISASTER_GATEWAY",
    tier: 'SS',
    waves:  [
        [ { type: "alexscaves:tremorsaurus", amount: 10 }, { type: "alexscaves:vallumraptor", amount: 10 }],
        [ { type: "alexscaves:tremorzilla", amount: 1 },  { type: "alexscaves:luxtructosaurus", amount: 1 }],
    ],
    description: "A prehistoric disaster.."
  }
  
  const FAILED_CONTAINMENT = {
    gateId: "CONTAINMENT_FAILURE_GATEWAY",
    tier: 'SS',
    waves:  [
        [ { type: "bossominium:fallarota_boss", amount: 1 },  { type: "alexscaves:raycat", amount: 10}, { type: "irons_spellbooks:necromancer", amount: 7 },],
    ],
    description: "!!!"
  }

  
  const IGNIS_GATEWAY = {
    gateId: "IGNIS_GATEWAY",
    tier: 'SS',
    waves:  [
        [ { type: "cataclysm:ignited_berserker", amount: 17 }, { type: "cataclysm:ignited_revenant", amount: 15 }],
        [ { type: "cataclysm:ignis", amount: 1 }],
    ],
    description: "A fiery guardian.."   
  }
  
  /*
  
  SSS Gateways
  
  */
  
  const LIGHTNING_DRAGON_LAIR = {
    gateId: "LIGHTNING_DRAGON_LAIR",
    tier: 'SSS',
    waves:  [
        [ { type: "iceandfire:lightning_dragon", amount: 1, size: 5 }, { type: "iceandfire:lightning_dragon", amount: 3, size: 4 }, { type: "iceandfire:lightning_dragon", amount: 5, size: 3 }, { type: "iceandfire:lightning_dragon", amount: 7, size: 2 },  { type: "iceandfire:lightning_dragon", amount: 11, size: 1 }],
    ],
    description: "Prepare an army of knights.. you'll need them.."  
  }
  
  const FIRE_DRAGON_LAIR = {
    gateId: "FIRE_DRAGON_LAIR",
    tier: 'SSS',
    waves:  [
        [ { type: "iceandfire:fire_dragon", amount: 1, size: 5 }, { type: "iceandfire:fire_dragon", amount: 3, size: 4 }, { type: "iceandfire:fire_dragon", amount: 5, size: 3 }, { type: "iceandfire:fire_dragon", amount: 7, size: 2 },  { type: "iceandfire:fire_dragon", amount: 11, size: 1 }],
    ],
    description: "Prepare an army of knights.. you'll need them.."  
  }      
  
  const ICE_DRAGON_LAIR = {
    gateId: "ICE_DRAGON_LAIR",
    tier: 'SSS',
    waves:  [
        [ { type: "iceandfire:ice_dragon", amount: 1, size: 5 }, { type: "iceandfire:ice_dragon", amount: 3, size: 4 }, { type: "iceandfire:ice_dragon", amount: 5, size: 3 }, { type: "iceandfire:ice_dragon", amount: 7, size: 2 },  { type: "iceandfire:ice_dragon", amount: 11, size: 1 }],
    ],
    description: "Prepare an army of knights.. you'll need them.."  
  }           
  
  const NETHERITE_FACTORY = {
    gateId: "NETHERITE_FACTORY",
    tier: 'SSS',
    waves:  [
        [ { type: "cataclysm:netherite_monstrosity", amount: 1 }, { type: "iceandfire:fire_dragon", amount: 2, size: 5 }, { type: "bossominium:golden_ring_boss", amount: 5}],
    ],
    description: "Amongst the hellscape one colossal netherite entity stands.."
  }


  const FORSAKEN_HEART_GATEWAY = {
    gateId: "FORSAKEN_HEART",
    tier: 'SSS',
    waves: [
        [ { type: "cataclysm:netherite_monstrosity", amount: 2 }, { type: "bossominium:netherrack_heart_boss", amount: 1 }, { type: "minecraft:warden", amount: 10}],
    ],
    description: "The end is near.."
  }

  const LARGER_THAN_MOUNTAINS_GATEWAY = {
    gateId: "LARGER_THAN_MOUNTAINS_GATEWAY",
    tier: 'SSS',
    waves:  [
        [ { type: "cataclysm:coral_golem", amount: 7 }, { type: "cataclysm:ender_golem", amount: 3 }],
        [ { type: "bossominium:chorus_beast_boss", amount: 1}, { type: "cataclysm:ender_guardian", amount: 3 },],
        [ { type: "cataclysm:netherite_monstrosity", amount: 2 }, { type: "alexscaves:tremorzilla"}],
    ],
    description: "Rock solid.."
  }
  
  const DEMON_KINGS_FINAL_STAND = {
    gateId: "DEMON_KINGS_FINAL_STAND",
    tier: 'SSS',
    waves: [
      [
        { type: "realmrpg_demons:imp_guard", amount: 15 },
        { type: "realmrpg_demons:demon", amount: 25 },
        { type: "realmrpg_demons:demon_lord", amount: 8 },
        { type: "minecraft:wither_skeleton", amount: 12 },
        { type: "bygonenether:wither_skeleton_knight", amount: 8 }
      ],
      [
        { type: "realmrpg_demons:demon", amount: 35 },
        { type: "realmrpg_demons:demon_lord", amount: 12 },
        { type: "realmrpg_demons:ancient_demon_lord", amount: 4 },
        { type: "minecraft:wither_skeleton", amount: 15 },
        { type: "bygonenether:wither_skeleton_knight", amount: 10 },
      ],
      [
        { type: "realmrpg_demons:demon_lord", amount: 15 },
        { type: "realmrpg_demons:ancient_demon_lord", amount: 6 },
        { type: "minecraft:wither", amount: 2 },
        { type: "bossominium:hell_hound_boss", amount: 1 },
        { type: "cataclysm:netherite_monstrosity", amount: 1 },
        { type: "cataclysm:ignis", amount: 1 }
      ],
      [
        { type: "realmrpg_demons:ancient_demon_lord", amount: 8 },
        { type: "cataclysm:netherite_monstrosity", amount: 1 },
        { type: "minecraft:wither", amount: 3 },
        { type: "bossominium:hell_hound_boss", amount: 2 }
      ],
      [
        { type: "cataclysm:ignis", amount: 1 },
        { type: "cataclysm:netherite_monstrosity", amount: 1 },
        { type: "realmrpg_demons:ancient_demon_lord", amount: 6 },
        { type: "minecraft:wither", amount: 4 }
      ]
    ],
    description:
      "The Demon King's final stand, an overwhelming force of ancient demons, withers, and mighty monstrosities awaits..."
  };

  /*

    SSSS TIER NIGHTMARE GATEWAYS

  */

  const NIGHTMARE_GATEWAY = {
    gateId: "NIGHTMARE_GATEWAY",
    tier: 'SSSS',
    waves: [
        // B Tier Waves - Starting with relatively "manageable" challenges
        [ { type: "alexscaves:tremorsaurus", amount: 4 }, { type: "irons_spellbooks:necromancer", amount: 5 }, { type: "minecraft:zombie", amount: 30 } ],
        [ { type: "iceandfire:fire_dragon", amount: 1, size: 2 }, { type: "bygonenether:wex", amount: 10 }, { type: "iceandfire:cockatrice", amount: 10 } ],
  
        // A Tier Waves - Increasing difficulty with formidable creatures
        [ { type: "iceandfire:lightning_dragon", amount: 1, size: 3 }, { type: "mutantmonsters:mutant_zombie", amount: 5 }, { type: "iceandfire:cyclops", amount: 2 } ],
        [ { type: "cataclysm:ender_golem", amount: 3 }, { type: "cataclysm:kobolediator", amount: 4 }, { type: "irons_spellbooks:citadel_keeper", amount: 3 } ],
  
        // S Tier Waves - Introducing elite monsters with more power
        [ { type: "iceandfire:hydra", amount: 2 }, { type: "mutantmonsters:mutant_skeleton", amount: 4 }, { type: "iceandfire:amphithere", amount: 3 } ],
        [ { type: "realmrpg_demons:demon_lord", amount: 1 }, { type: "iceandfire:ice_dragon", amount: 2, size: 4 }, { type: "minecraft:wither", amount: 2 } ],
  
        // SS Tier Waves - Testing survival with overpowered beings
        [ { type: "cataclysm:ender_golem", amount: 5 }, { type: "cataclysm:netherite_monstrosity", amount: 1 }, { type: "realmrpg_demons:ancient_demon_lord", amount: 1 } ],
        [ { type: "iceandfire:fire_dragon", amount: 1, size: 5 }, { type: "realmrpg_wyrms:red_wyrm", amount: 10 }, { type: "cataclysm:ignited_berserker", amount: 10 } ],
  
  
        // SSS Tier Waves - Unrelenting onslaught
        [ { type: "cataclysm:ender_golem", amount: 7 }, { type: "iceandfire:hydra", amount: 12 }, { type: "cataclysm:ender_guardian", amount: 7 } ],
        [ { type: "iceandfire:ice_dragon", amount: 1, size: 5 }, { type: "iceandfire:lightning_dragon", amount: 1, size: 5 }, { type: "cataclysm:netherite_monstrosity", amount: 2 } ],
  
  
        // SSSS Tier Wave - The final and hardest wave
        [ { type: "realmrpg_demons:ancient_demon_lord", amount: 3 }, { type: "minecraft:wither", amount: 3 }, { type: "cataclysm:netherite_monstrosity", amount: 3 }, { type: "iceandfire:fire_dragon", amount: 5, size: 5 } ]
    ],
    description: "An unending nightmare of overwhelming waves, filled with progressively stronger and deadlier creatures. Only the strongest survive."
  };
  
  
  const GATEWAY_TYPES = [
    // F Tier Gateways
    SLIME_GATEWAY,
    UNDEAD_HORDE_GATEWAY,
    HAUNTED_GATEWAY,
    PIXIE_SWARM_GATEWAY,
    DREAD_THRALL_INVASION_GATEWAY,
    WYRMS_INFESTATION_GATEWAY,
    SKELETON_MARCH_GATEWAY,
    PHANTOM_NIGHT_GATEWAY,
    KOBOLD_RAID_GATEWAY,
  
    // E Tier Gateways
    COCKATRICE_NEST_GATEWAY,
    DEMON_SCOUTING_PARTY_GATEWAY,
    BABY_DINOSAUR_GATEWAY,
    SKELETAL_WARRIORS_GATEWAY,
    IMP_HORDES_GATEWAY,
    DREAD_KNIGHTS_GATEWAY,
    CREEPER_CHAOS_GATEWAY,
  
    // D Tier Gateways
    GORGON_GAZE_GATEWAY,
    OVERSIZED_WILDLIFE_GATEWAY,
    ZOMBIE_HORDE_GATEWAY,
    DREAD_GATEWAY,
    DEMON_SQUAD_GATEWAY,
    DEMON_ASSAULT_GATEWAY,
    AMPHITHERE_ATTACK_GATEWAY,
    TROLL_INVASION_GATEWAY,
    INFERNAL_SCOUTS_GATEWAY,
  
    // C Tier Gateways
    ONE_EYED_GATEWAY,
    INFERNAL_GATEWAY,
    GIANT_GATEWAY,
    MYTHICAL_BEASTS_GATEWAY,
    WARDEN_OF_THE_DEPTHS_GATEWAY,
    MUTANT_MAYHEM_GATEWAY,
    CITADEL_DEFENDERS_GATEWAY,
    DEMONIC_LORD_GATEWAY,
  
    // B Tier Gateways
    BABY_DRAGON_GATEWAY,
    DEAD_KING_GATEWAY,
    DINOSAUR_GATEWAY,
    CITADEL_SIEGE_GATEWAY,
    WITHER_ASSAULT_GATEWAY,
    DEMONIC_OVERLORD_GATEWAY,
  
    // A Tier Gateways
    ICE_TWINS_GATEWAY,
    LIGHTNING_PREDATOR_GATEWAY,
    TWIN_HEADED_GATEWAY,
    CASTLE_GUARDS_GATEWAY,
    THE_UNDEAD_ARMY,
    FROST_DRAGON_ASSAULT_GATEWAY,
    NETHERITE_GUARDIANS_GATEWAY,
    ANCIENT_DEMON_GATEWAY,
    ELEMENTAL_CLASH_GATEWAY,
    
    // S Tier Gateways
    APEX_PREDATOR_GATEWAY,
    ENDER_GOLEMS_GATEWAY,
    SNAKES_AND_BIRDS_GATEWAY,
    DEMON_KINGS_CASTLE_WAR,
    OVER_THE_RAINBOW_GATEWAY,
    SMAUG_THE_DRAGON_GATEWAY,

    // SS Tier Gateways
    LARGER_THAN_BOULDERS_GATEWAY,
    PREHISTORICAL_DISASTER_GATEWAY,
    IGNIS_GATEWAY,
    THE_GUARDIAN_GATEWAY,
    FAILED_CONTAINMENT,
  
    // SSS Tier Gateways
    LIGHTNING_DRAGON_LAIR,
    FIRE_DRAGON_LAIR,
    ICE_DRAGON_LAIR,
    NETHERITE_FACTORY,
    FORSAKEN_HEART_GATEWAY,
    LARGER_THAN_MOUNTAINS_GATEWAY,
    DEMON_KINGS_FINAL_STAND,

    // SSSS Tier Gateways
    NIGHTMARE_GATEWAY
  ];
  
  function getTierColor(tier) {
    switch (tier) {
        case 'F': return '§7'; // Gray
        case 'E': return '§8'; // Dark Gray
        case 'D': return '§a'; // Green
        case 'C': return '§2'; // Dark Green
        case 'B': return '§9'; // Blue
        case 'A': return '§e'; // Yellow
        case 'S': return '§6'; // Gold
        case 'SS': return '§c'; // Red
        case 'SSS': return '§4'; // Dark Red
        case 'SSSS': return '§5'; // Dark Purple
        default: return '§f'; // White
    }
  }
  
  function formatGateName(gateName) {
    return gateName
        .toLowerCase()
        .replace(/_/g, ' ')
        .replace(/\b\w/g, c => c.toUpperCase())
        .replace(/way$/, '');
  }
  
  let activeGateways = [];
  let playerGatewayEntries = {};
  
  ServerEvents.tick(event => {
    // Only update every 20 ticks (1 second) to reduce performance impact
    if (event.server.getLevel('overworld').getTime() % 20 !== 0) return;
  
    // Increase the size of all gateways by 7x
    event.server.runCommandSilent('scale set pehkui:base 7 @e[type=gateways:normal_gateway]');
  
    // Check player proximity to gateways
    const players = event.server.getPlayers();
    players.forEach(player => {
        const playerPos = {
            x: player.getX(),
            y: player.getY(),
            z: player.getZ()
        };
  
        activeGateways.forEach(gateway => {
            const distance = Math.sqrt(
                Math.pow(playerPos.x - gateway.pos.x, 2) +
                Math.pow(playerPos.y - gateway.pos.y, 2) +
                Math.pow(playerPos.z - gateway.pos.z, 2)
            );
  
            if (distance <= 64) {
                const playerId = player.uuid;
                const gatewayId = `${gateway.id}-${gateway.pos.x}-${gateway.pos.y}-${gateway.pos.z}`;
  
                if (!playerGatewayEntries[playerId]) {
                    playerGatewayEntries[playerId] = {};
                }
  
                if (!playerGatewayEntries[playerId][gatewayId]) {
                    playerGatewayEntries[playerId][gatewayId] = true;
                    const tierColor = getTierColor(gateway.tier);
                    const message = `A player has entered the range of: §b${tierColor}[${gateway.tier}] ${tierColor}${formatGateName(gateway.gateId)}§r gateway! §7Location: [${gateway.pos.x}, ${gateway.pos.y}, ${gateway.pos.z}]`;
                    console.log(message)
                    event.server.runCommandSilent(`tellraw @a {"text":"${message}"}`);
                }
            }
        });
    });
  });
  
  const GATE_GROUND_OFFSET = 8;
  
  
  function formatDuration(ms) {
    const totalSeconds = Math.floor(ms / 1000);
    const seconds = totalSeconds % 60;
    const totalMinutes = Math.floor(totalSeconds / 60);
    const minutes = totalMinutes % 60;
    const hours = Math.floor(totalMinutes / 60);
  
    let result = '';
    if (hours > 0) result += `${hours}h `;
    if (minutes > 0) result += `${minutes}m `;
    if (seconds > 0 || result === '') result += `${seconds}s`;
  
    return result.trim();
  }
  
  ServerEvents.commandRegistry(event => {
    const { commands: Commands, arguments: Arguments } = event;
    const RADIUS = 4000;
  
  
  
    function selectRandomGateway(tier) {
        const tierGateways = GATEWAY_TYPES.filter(gateway => gateway.tier == tier);
        const randomGateway = tierGateways[Math.floor(Math.random() * tierGateways.length)];
        console.log(randomGateway);
        if (randomGateway == undefined) {
            console.log(`NO GATEWAY FOUND FOR TIER: ${tier}`);
            return;
        }
        return `${randomGateway.tier}.${randomGateway.gateId}`;
    }
  
    function spawnGateway(ctx, id, pos, gateway) {
        const server = ctx.source.getServer();
        const level = server.getLevel('overworld');
  
        // Forceload the chunk
        server.runCommandSilent(`forceload add ${pos.x} ${pos.z}`);
        console.log(`Forceloaded chunk at ${pos.x}, ${pos.z} for portal: ${gateway.gateId}`);
  
        // Wait 20 ticks to ensure the chunk is loaded
        server.scheduleInTicks(20, () => {
            // Get the highest Y level at the position and add offset
            pos.y = level.getHeight("world_surface", pos.x, pos.z) + GATE_GROUND_OFFSET;
  
            const command = `summon gateways:normal_gateway ${pos.x} ${pos.y} ${pos.z} {active:0b,wave:0,wave_entities:[L;],queued_stacks:[],CustomName:'{"color":"#4B0082","translate":"${formatGateName(gateway.gateId)}"}',gate:"custom-gateways:${id.replace('.', '/').toLowerCase()}"}`;
  
            console.log(`Spawning gateway with command: ${command}`);
            server.runCommandSilent(command);
  
            // Schedule forceload removal after 1 hour and 5 minutes (3900 seconds)
            server.scheduleInTicks(3900 * 20, () => {
                console.log(`Unloaded ${pos.x} ${pos.z} for portal: ${gateway.gateId}`);
                server.runCommandSilent(`forceload remove ${pos.x} ${pos.z}`);
  
                // Remove from activeGateways
                activeGateways = activeGateways.filter(g => !(g.pos.x === pos.x && g.pos.z === pos.z));
            });
  
            // Add to activeGateways
            activeGateways.push({
                id: id,
                pos: { x: pos.x, y: pos.y, z: pos.z },
                tier: gateway.tier,
                gateId: gateway.gateId,
                description: gateway.description,
                timeSpawned: Date.now(),
                timeToDespawn: Date.now() + 1.5 * 60 * 60 * 1000 // 1.5 hours in ms
            });
  
            const tierColor = getTierColor(gateway.tier);
            const message = [
                `${tierColor}§l§m══════════════════`,
                ``,
                `${tierColor}§lA new ${gateway.tier} tier gateway has spawned!`,
                `${tierColor}§7${gateway.description}`,
                `${tierColor}Coordinates: §a§l (${pos.x}, ${pos.y}, ${pos.z})`,
                ``,
                `${tierColor}§l§m══════════════════`
            ].join('\n');
  
            server.runCommandSilent(`tellraw @a {"text":"${message.replace(/\n/g, '\\n')}"}`);
        });
  
        return 1;
    }
  
    function scheduleGateway(ctx, id, delay) {
        const server = ctx.source.getServer();
        const announceTimes = [300, 60, 10];
        const announceMessages = {
            600: "10 minutes",
            300: "5 minutes",
            120: "2 minutes",
            60: "1 minute",
            30: "30 seconds",
            10: "10 seconds",
            5: "5 seconds",
            4: "4 seconds",
            3: "3 seconds",
            2: "2 seconds",
            1: "1 second"
        };
  
        // Handle random gate selection
        id = !id.endsWith('.RANDOM_GATEWAY') ? id : selectRandomGateway(id.substring(0, id.indexOf('.')));
        const gateway = GATEWAY_TYPES.find(g => `${g.tier}.${g.gateId}` === id);
  
        const tierColor = getTierColor(gateway.tier);
        const level = server.getLevel('overworld');
        const x = Math.floor(Math.random() * (RADIUS * 2)) - RADIUS;
        const z = Math.floor(Math.random() * (RADIUS * 2)) - RADIUS;
        const pos = { x: x, y: 0, z: z };
  
        // Forceload the chunk
        server.runCommand(`forceload add ${pos.x} ${pos.z}`);
        console.log(`Forceloaded chunk at ${pos.x}, ${pos.z} for scheduled portal: ${gateway.gateId}`);
  
        // Schedule the spawning after the delay
        server.scheduleInTicks(delay * 20, () => {
            // Wait 20 ticks to ensure the chunk is loaded
            server.scheduleInTicks(20, () => {
                // Get the highest Y level at the position and add offset
                pos.y = level.getHeight("world_surface", pos.x, pos.z) + GATE_GROUND_OFFSET;
  
                const command = `summon gateways:normal_gateway ${pos.x} ${pos.y} ${pos.z} {active:0b,wave:0,wave_entities:[L;],queued_stacks:[],CustomName:'{"color":"#4B0082","translate":"${formatGateName(gateway.gateId)}"}',gate:"custom-gateways:${id.replace('.', '/').toLowerCase()}"}`;
  
                console.log(`Spawning scheduled gateway with command: ${command}`);
                server.runCommandSilent(command);
  
                // Schedule forceload removal after 1 hour and 5 minutes (3900 seconds)
                server.scheduleInTicks(3900 * 20, () => {
                    console.log(`Unloaded ${pos.x} ${pos.z} for portal: ${gateway.gateId}`);
                    server.runCommandSilent(`forceload remove ${pos.x} ${pos.z}`);
  
                    // Remove from activeGateways
                    activeGateways = activeGateways.filter(g => !(g.pos.x === pos.x && g.pos.z === pos.z));
                });
  
                // Add to activeGateways
                activeGateways.push({
                    id: id,
                    pos: { x: pos.x, y: pos.y, z: pos.z },
                    tier: gateway.tier,
                    gateId: gateway.gateId,
                    description: gateway.description,
                    timeSpawned: Date.now(),
                    timeToDespawn: Date.now() + 1.5 * 60 * 60 * 1000 // 1.5 hours in ms
                });
  
                const tierColor = getTierColor(gateway.tier);
                const message = [
                    `${tierColor}§l§m══════════════════`,
                    ``,
                    `${tierColor}§lA new ${gateway.tier} tier gateway has spawned!`,
                    `${tierColor}§7${gateway.description}`,
                    `${tierColor}Coordinates: §a§l (${pos.x}, ${pos.y}, ${pos.z})`,
                    ``,
                    `${tierColor}§l§m══════════════════`
                ].join('\n');
  
                server.runCommandSilent(`tellraw @a {"text":"${message.replace(/\n/g, '\\n')}"}`);
            });
        });
  
        // Announcements
        announceTimes.forEach(time => {
            if (delay >= time) {
                if ((delay - time) * 20 >= 0) {
                    server.scheduleInTicks((delay - time) * 20, () => {
                        server.runCommand(`tellraw @a {"text":"${tierColor}A new §l${gateway.tier}§r${tierColor} tier §lgateway§r${tierColor} will spawn in ${announceMessages[time]}! §7[x: ${pos.x}, z: ${pos.z}]§r"}`);
                    });
                }
            } 
        });
  
        ctx.source.sendSuccess(Text.of(`${tierColor}[Gateway] §eScheduled a new ${gateway.tier} tier gateway to spawn in ${delay} seconds at §7[x: ${pos.x}, z: ${pos.z}]§r.`), false);
        return 1;
    }
  
    event.register(
        Commands.literal('spawn-gateway')
            .requires(s => s.hasPermission(2))
            .then(Commands.argument('id', Arguments.STRING.create(event))
                .suggests((ctx, builder) => {
                    GATEWAY_TYPES.forEach(gateway => {
                        builder.suggest(`${gateway.tier}.${gateway.gateId}`);
                    });
                    // Add suggestions for random gates
                    const tiers = {};
                    GATEWAY_TYPES.forEach(gateway => {
                        tiers[gateway.tier] = true;
                    });
                    Object.keys(tiers).forEach(tier => {
                        builder.suggest(`${tier}.RANDOM_GATEWAY`);
                    });
                    return builder.buildFuture();
                })
                .then(Commands.argument('pos', Arguments.BLOCK_POS.create(event))
                    .executes(ctx => {
                        let id = Arguments.STRING.getResult(ctx, 'id');
                        const pos = Arguments.BLOCK_POS.getResult(ctx, 'pos');
                        const server = ctx.source.getServer();
                        const level = server.getLevel('overworld');
                        id = !id.endsWith('.RANDOM_GATEWAY') ? id : selectRandomGateway(id.substring(0, id.indexOf('.')));
                        const gateway = GATEWAY_TYPES.find(g => `${g.tier}.${g.gateId}` === id);
  
                        // Forceload the chunk
                        server.runCommand(`forceload add ${pos.x} ${pos.z}`);
                        console.log(`Forceloaded chunk at ${pos.x}, ${pos.z} for portal: ${gateway.gateId}`);
  
                        // Wait 20 ticks to ensure the chunk is loaded
                        server.scheduleInTicks(20, () => {
                            // Get the highest Y level at the position and add offset
                            pos.y = level.getHeight("world_surface", pos.x, pos.z) + GATE_GROUND_OFFSET;
  
                            const command = `summon gateways:normal_gateway ${pos.x} ${pos.y} ${pos.z} {active:0b,wave:0,wave_entities:[L;],queued_stacks:[],CustomName:'{"color":"#4B0082","translate":"${formatGateName(gateway.gateId)}"}',gate:"custom-gateways:${id.replace('.', '/').toLowerCase()}"}`;
  
                            console.log(`Spawning gateway with command: ${command}`);
                            server.runCommandSilent(command);
  
                            // Schedule forceload removal after 1 hour and 5 minutes (3900 seconds)
                            server.scheduleInTicks(3900 * 20, () => {
                                console.log(`Unloaded ${pos.x} ${pos.z} for portal: ${gateway.gateId}`);
                                server.runCommandSilent(`forceload remove ${pos.x} ${pos.z}`);
  
                                // Remove from activeGateways
                                activeGateways = activeGateways.filter(g => !(g.pos.x === pos.x && g.pos.z === pos.z));
                            });
  
                            // Add to activeGateways
                            activeGateways.push({
                                id: id,
                                pos: { x: pos.x, y: pos.y, z: pos.z },
                                tier: gateway.tier,
                                gateId: gateway.gateId,
                                description: gateway.description,
                                timeSpawned: Date.now(),
                                timeToDespawn: Date.now() + 60 * 60 * 1000 // 1.5 hours in ms
                            });
  
                            const tierColor = getTierColor(gateway.tier);
                            const message = [
                                `${tierColor}§l§m══════════════════`,
                                ``,
                                `${tierColor}§lA new ${gateway.tier} tier gateway has spawned!`,
                                `${tierColor}§7${gateway.description}`,
                                `${tierColor}Coordinates: §a§l (${pos.x}, ${pos.y}, ${pos.z})`,
                                ``,
                                `${tierColor}§l§m══════════════════`
                            ].join('\n');
  
                            server.runCommandSilent(`tellraw @a {"text":"${message.replace(/\n/g, '\\n')}"}`);
                        });
  
                        return 1;
                    })
                )
            )
    );
  
    event.register(
        Commands.literal('schedule-gateway')
            .requires(s => s.hasPermission(2))
            .then(Commands.argument('id', Arguments.STRING.create(event))
                .suggests((ctx, builder) => {
                    GATEWAY_TYPES.forEach(gateway => {
                        builder.suggest(`${gateway.tier}.${gateway.gateId}`);
                    });
                    // Add suggestions for random gates
                    const tiers = {};
                    GATEWAY_TYPES.forEach(gateway => {
                        tiers[gateway.tier] = true;
                    });
                    Object.keys(tiers).forEach(tier => {
                        builder.suggest(`${tier}.RANDOM_GATEWAY`);
                    });
                    return builder.buildFuture();
                })
                .then(Commands.argument('delay', Arguments.INTEGER.create(event))
                    .executes(ctx => {
                        const id = Arguments.STRING.getResult(ctx, 'id');
                        const delay = Arguments.INTEGER.getResult(ctx, 'delay');
                        return scheduleGateway(ctx, id, delay);
                    })
                )
            )
    );
  
    function announceGatewayDefeated(server, gateway) {
        const tierColor = getTierColor(gateway.tier);
        const message = [
            `${tierColor}§l§m══════════════════`,
            ``,
            `${tierColor}§lAn ${gateway.tier} tier gateway has been defeated!`,
            `${tierColor}Name: §l${formatGateName(gateway.gateId)}`,
            ``,
            `${tierColor}Congratulations to all warriors!`,
            ``,
            `${tierColor}§l§m══════════════════`
        ].join('\n');
    
        server.runCommandSilent(`tellraw @a {"text":"${message.replace(/\n/g, '\\n')}"}`);
    }
  
    event.register(
        Commands.literal('list-gateways')
            .requires(s => s.hasPermission(2))
            .executes(ctx => {
                if (activeGateways.length === 0) {
                    ctx.source.sendSuccess(Text.of("No active gateways."), false);
                    return 1;
                }
                let message = `${activeGateways.length} Active Gateways:\n`;
                activeGateways.forEach(g => {
                    const tierColor = getTierColor(g.tier);
                    const elapsedTimeMs = Date.now() - g.timeSpawned;
                    const timeLeftMs = g.timeToDespawn - Date.now();
                    const spawnedAgo = formatDuration(elapsedTimeMs);
                    const despawnsIn = formatDuration(timeLeftMs);
                    message += `${tierColor}[${g.tier}] ${formatGateName(g.gateId)}§r at (${g.pos.x}, ${g.pos.y}, ${g.pos.z}), spawned ${spawnedAgo} ago, despawns in ${despawnsIn}\n`;
                });
                ctx.source.sendSuccess(Text.of(message), false);
                return 1;
            })
    );
    
    // Command to mark a gateway as completed
    event.register(
        Commands.literal('completed-gateway')
            .requires(s => s.hasPermission(2))
            .then(Commands.argument('id', Arguments.STRING.create(event))
            .executes(ctx => {
                const gatewayId = Arguments.STRING.getResult(ctx, 'id');
                const gateway = activeGateways.find(g => g.gateId === gatewayId);
            
                if (!gateway) {
                    ctx.source.sendFailure(Text.of(`No active gateway found with ID: ${gatewayId}`));
                    return 0;
                }
  
                // Remove the gateway from activeGateways
                const index = activeGateways.indexOf(gateway);
                if (index > -1) {
                    activeGateways.splice(index, 1);
                }
  
                // Announce that the gateway has been defeated
                announceGatewayDefeated(ctx.source.getServer(), gateway);
  
                ctx.source.sendSuccess(Text.of(`Gateway ${gatewayId} marked as completed and removed from active list.`), true);
                console.log(`Gateway ${gatewayId} completed`);
                return 1;
            })
        )
    );
  });