ServerEvents.recipes(event => {
    event.remove({output: 'botania:terrasteel_ingot', type: 'botania:terra_plate'})
    event.remove({output: 'iceandfire:dragonsteel_fire_ingot'})
    event.remove({output: 'iceandfire:dragonsteel_ice_ingot'})
    event.remove({output: 'iceandfire:dragonsteel_lightning_ingot'})
    event.remove({output: 'cataclysm:ignitium_upgrade_smithing_template'})
    event.remove({output: 'slashblade:proudsoul_ingot'})
    event.remove({output: 'origins:orb_of_origin'})
    event.remove({output: 'minecraft:bundle'})
    event.remove({output: 'apotheosis:sigil_of_socketing'});

    event.custom({
      type: 'botania:terra_plate',
      ingredients: [
        {
          item: 'minecraft:netherite_ingot'
        },
        {
          item: 'botania:mana_pearl'
        },
        {
          item: 'botania:mana_diamond'
        }
      ],
      result: {
        item: 'botania:terrasteel_ingot'
      },
      mana: 500000
    })

  function createRunicAltarRecipe(output, ingredients, mana) {
    return {
      type: 'botania:runic_altar',
      output: {
        item: output,
        count: 1
      },
      mana: mana,
      ingredients: ingredients.map(item => ({item: item}))
    }
  }

  event.custom({
    type: 'minecraft:crafting_shaped',
    pattern: [
      'SLS',
      'L L',
      'LLL'
    ],
    key: {
      S: {item: 'botania:mana_string'},
      L: {item: 'botania:livingwood_planks'}
    },
    result: {
      item: 'minecraft:bundle',
      count: 1
    }
  })
  
  event.custom({
    type: 'crafting_shaped',
    pattern: [
      'EDE',
      'DHD',
      'EDE'
    ],
    key: {
      E: 'botania:elementium_ingot',
      D: 'botania:mana_diamond_block',
      H: 'kubejs:heart'
    },
    result: {
      item: 'kubejs:origin_token',
      count: 1
    }
  })

  event.custom({
    type: 'crafting_shaped',
    pattern: [
      'HGH',
      'GBG',
      'HGH'
    ],
    key: {
      H: 'kubejs:heart',
      G: 'iceandfire:ghost_ingot',
      B: 'minecraft:beacon'
    },
    result: {
      item: 'kubejs:tracker',
      count: 1
    }
  })

  event.custom(createRunicAltarRecipe(
    'iceandfire:dragonsteel_fire_ingot',
    [
      'botania:terrasteel_ingot',
      'iceandfire:fire_dragon_blood',
      'iceandfire:dragonbone',
      'iceandfire:fire_dragon_heart',
      'irons_spellbooks:fire_rune',
      'botania:rune_wrath',
      'botania:rune_pride',
    ],
    500000
  ))

  event.custom(createRunicAltarRecipe(
    'slashblade:proudsoul_ingot',
    [
      'botania:rune_wrath',
      'slashblade:proudsoul',
      'botania:rune_pride',
      'botania:rune_envy',
      'botania:rune_sloth',
      'botania:rune_greed',
      'iceandfire:dragonsteel_ice_ingot',
      'botania:rune_lust',
      'botania:rune_wrath',
      'botania:rune_pride',
      'botania:rune_envy',
      'slashblade:proudsoul',

    ],
    2000000
  ))

  event.custom(createRunicAltarRecipe(
    'iceandfire:dragonsteel_ice_ingot',
    [
      'botania:terrasteel_ingot',
      'iceandfire:ice_dragon_blood',
      'iceandfire:dragonbone',
      'iceandfire:ice_dragon_heart',
      'irons_spellbooks:ice_rune',
      'botania:rune_envy',
      'botania:rune_sloth',
    ],
    500000
  ))


  event.custom(createRunicAltarRecipe(
    'iceandfire:dragonsteel_lightning_ingot',
    [
      'botania:terrasteel_ingot',
      'iceandfire:lightning_dragon_blood',
      'iceandfire:dragonbone',
      'iceandfire:lightning_dragon_heart',
      'irons_spellbooks:lightning_rune',
      'botania:rune_greed',
      'botania:rune_lust',
    ],
    500000
  ))

  event.custom({
    type: 'botania:terra_plate',
    ingredients: [
      {
        item: 'botania:gaia_ingot'
      },
      {
        item: 'iceandfire:dragonbone'
      },
      {
        item: 'botania:mana_diamond_block'
      },
      {
        item: 'iceandfire:dragonbone'
      },
    ],
    result: {
      item: 'cataclysm:ignitium_upgrade_smithing_template'
    },
    mana: 2000000
  })
  
    
  })


