// Define the AgeTicks for each tier
const tierAgeTicks = {
    "Tier 1 Dragon": 600,
    "Tier 2 Dragon": 600000,
    "Tier 3 Dragon": 1200000,
    "Tier 4 Dragon": 180000,
    "Tier 5 Dragon": 2400000
};

// Listen for the WaveEntitySpawned event
ForgeEvents.onEvent(`dev.shadowsoffire.gateways.event.GateEvent$WaveEntitySpawned`, event => {
    const entity = event.getWaveEntity();
    const name = entity.getName().getString();

    // Check if the dragon's name matches one of the tiers
    if (tierAgeTicks[name]) {
        entity.level.getServer().scheduleInTicks(5, () => {
            console.log(`Converted gateway dragon to proper age: ${name}`)
            // Set the AgeTicks based on the tier
            entity.level.getServer().runCommandSilent(`data merge entity ${entity.uuid} {AgeTicks:${tierAgeTicks[name]}}`);

            // Apply Instant Health effect with amplifier 50
            entity.level.getServer().runCommandSilent(`effect give ${entity.uuid} minecraft:instant_health 1 50 true`);
        });
    }
});
