const getOrigin = (player) => {
  const nbt = player.getNbt();
  if (nbt.ForgeCaps && nbt.ForgeCaps['origins:origins']) {
      const originsData = nbt.ForgeCaps['origins:origins'];
      const origin = originsData.Origins['origins:origin'];
      return origin;
  }
  return null;
}

Platform.mods.kubejs.name = 'Hexlite'

StartupEvents.registry('item', event => {
    event.create('origin_token')
      .rarity('epic')
      .unstackable()
      .glow(true)
      .displayName('Origin Randomizer')
      .texture('origins:item/orb_of_origin')
      .food(food => {
        food
          .hunger(10)
          .saturation(10)
          .alwaysEdible()
          .eaten(event => {
            const item = event.item;
            const nbt = item.nbt;
            const player = event.player;
            const server = Utils.server;
            if (nbt && nbt.Origin) {
              // Set the origin to the one specified in the NBT
              server.runCommandSilent(`origin set ${player.getName().getString()} origins:origin ${nbt.Origin}`);
            } else {
              // Randomly set the origin if no NBT is present
              server.runCommandSilent(`origin random ${player.getName().getString()} origins:origin`);
             // Schedule the announcement
              server.scheduleInTicks(20, () => {
                const newOrigin = getOrigin(player);
                if (newOrigin) {
                  server.runCommandSilent(`tellraw @a {"text":"§f${player.getName().getString()}§7 has rolled the origin: §l§d${newOrigin.split(':')[1].replace('_', ' ').toUpperCase()}§r"}`);
                  }
                });
              }
          });
      });

      event.create('tracker')
      .rarity('alexscaves:nuclear')
      .unstackable()
      .displayName('Tracker')
      .glow(true)
      .texture('alexscaves:item/fissile_core')

      event.create('heart')
        .rarity('alexscaves:demonic')
        .maxStackSize(10)
        .displayName(Text.gold(`Heart Crystal`).bold())
        .tooltip(`Right click to gain 1 heart permanently`)
        .glow(true)
        .texture('scalinghealth:item/enchanted_heart')

      // Gem related items
      event.create('item_enhancer')
        .maxStackSize(16)
        .glow(true)
        .texture('apotheosis:items/gems/additional_attributes_iss/power_eldritch')

      event.create('undiscovered_gem')
        .maxStackSize(64)
        .texture('apotheosis:items/gems/additional_attributes_iss/spell_holy')
});
